package com.dowerx.quack.service;

import android.content.Context;
import android.util.Log;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.loader.content.AsyncTaskLoader;

import com.dowerx.quack.model.Post;
import com.dowerx.quack.model.User;
import com.google.android.gms.tasks.Task;
import com.google.android.gms.tasks.Tasks;
import com.google.firebase.firestore.CollectionReference;
import com.google.firebase.firestore.DocumentSnapshot;
import com.google.firebase.firestore.FirebaseFirestore;
import com.google.firebase.firestore.Query;
import com.google.firebase.firestore.QueryDocumentSnapshot;
import com.google.firebase.firestore.QuerySnapshot;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.atomic.AtomicBoolean;

public class PostService {
    public static class GetFeed extends AsyncTaskLoader<List<Post>> {

        public GetFeed(@NonNull Context context) {
            super(context);
        }

        @Nullable
        @Override
        public List<Post> loadInBackground() {
            List<Post> posts = new LinkedList<>();

            FirebaseFirestore db = FirebaseFirestore.getInstance();
            try {
                for (QueryDocumentSnapshot post : Tasks.await(db.collection("/post").limit(10).get())) {
                    DocumentSnapshot user = Tasks.await(post.getDocumentReference("user").get());
                    String username = user.get("username", String.class);
                    String userid = user.get("id", String.class);
                    posts.add(new Post(
                            new User(username, "", userid),
                            post.get("content", String.class),
                            post.get("image", String.class),
                            0,
                            false,
                            post.getId()
                    ));
                }
            } catch (ExecutionException | InterruptedException e) {
                throw new RuntimeException(e);
            }

            return posts;
        }

        @Override
        protected void onStartLoading() {
            forceLoad();
        }
    }
}
